# Generated by Django 5.1.8 on 2025-07-03 08:36

import django.db.models.deletion
import taggit.managers
import utilities.json
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('adestis_netbox_applications', '0006_alter_installedapplication_options_and_more'),
        ('dcim', '0200_populate_mac_addresses'),
        ('extras', '0123_journalentry_kind_default'),
        ('taggit', '0006_rename_taggeditem_content_type_object_id_taggit_tagg_content_8fc721_idx'),
        ('tenancy', '0017_natural_ordering'),
        ('virtualization', '0048_populate_mac_addresses'),
    ]

    operations = [
        migrations.CreateModel(
            name='Certificate',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('status', models.CharField(max_length=50)),
                ('comments', models.TextField(blank=True)),
                ('name', models.CharField(max_length=150)),
                ('description', models.CharField(blank=True, max_length=500)),
                ('subject', models.CharField(blank=True, max_length=2000)),
                ('supplier_product', models.CharField(blank=True, max_length=2000)),
                ('issuer', models.CharField(blank=True, max_length=2000)),
                ('subject_key_identifier', models.CharField(max_length=40, unique=True)),
                ('key_technology', models.CharField(blank=True, max_length=2000)),
                ('subject_alternative_name', models.CharField(blank=True, max_length=2000, null=True)),
                ('valid_from', models.DateField(blank=True, null=True)),
                ('valid_to', models.DateField(blank=True, null=True)),
                ('certificate', models.CharField(max_length=10000, unique=True)),
                ('authority_key_identifier', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='authority_certificates', to='adestis_netbox_certificate_management.certificate')),
                ('contact_group', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='certificate', to='tenancy.contactgroup')),
                ('installedapplication', models.ManyToManyField(blank=True, related_name='certificate', to='adestis_netbox_applications.installedapplication')),
                ('issuer_parent_certificate', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='issued_certificates', to='adestis_netbox_certificate_management.certificate')),
                ('predecessor_certificate', models.ManyToManyField(blank=True, related_name='certificate', to='adestis_netbox_certificate_management.certificate')),
                ('successor_certificates', models.ManyToManyField(blank=True, related_name='certificate', to='adestis_netbox_certificate_management.certificate')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
                ('tenant', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='certificate_tenant', to='tenancy.tenant')),
                ('tenant_group', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='certificate_tenant_group', to='tenancy.tenantgroup')),
            ],
            options={
                'verbose_name': 'Certificate',
                'verbose_name_plural': 'Certificates',
            },
        ),
        migrations.CreateModel(
            name='ClusterAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('certificate', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_certificate_management.certificate')),
                ('cluster', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='certificate_cluster_assignments', to='virtualization.cluster')),
                ('tags', taggit.managers.TaggableManager(through='taggit.TaggedItem', to='taggit.Tag')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='certificate',
            name='cluster',
            field=models.ManyToManyField(blank=True, related_name='certificate', through='adestis_netbox_certificate_management.ClusterAssignment', to='virtualization.cluster'),
        ),
        migrations.CreateModel(
            name='ClusterGroupAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('certificate', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_certificate_management.certificate')),
                ('cluster_group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='certificate_cluster_group_assignments', to='virtualization.clustergroup')),
                ('tags', taggit.managers.TaggableManager(through='taggit.TaggedItem', to='taggit.Tag')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='certificate',
            name='cluster_group',
            field=models.ManyToManyField(blank=True, related_name='certificate', through='adestis_netbox_certificate_management.ClusterGroupAssignment', to='virtualization.clustergroup'),
        ),
        migrations.CreateModel(
            name='ContactAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('certificate', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_certificate_management.certificate')),
                ('contact', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='certificate_contact_assignment', to='tenancy.contact')),
                ('tags', taggit.managers.TaggableManager(through='taggit.TaggedItem', to='taggit.Tag')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='certificate',
            name='contact',
            field=models.ManyToManyField(blank=True, related_name='certificate', through='adestis_netbox_certificate_management.ContactAssignment', to='tenancy.contact'),
        ),
        migrations.CreateModel(
            name='DeviceAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('certificate', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_certificate_management.certificate')),
                ('device', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='certificate_device_assignments', to='dcim.device')),
                ('tags', taggit.managers.TaggableManager(through='taggit.TaggedItem', to='taggit.Tag')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='certificate',
            name='device',
            field=models.ManyToManyField(blank=True, related_name='certificate', through='adestis_netbox_certificate_management.DeviceAssignment', to='dcim.device'),
        ),
        migrations.CreateModel(
            name='VirtualMachineAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('certificate', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_certificate_management.certificate')),
                ('tags', taggit.managers.TaggableManager(through='taggit.TaggedItem', to='taggit.Tag')),
                ('virtual_machine', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='certificate_virtual_machine_assignments', to='virtualization.virtualmachine')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='certificate',
            name='virtual_machine',
            field=models.ManyToManyField(blank=True, related_name='certificate', through='adestis_netbox_certificate_management.VirtualMachineAssignment', to='virtualization.virtualmachine'),
        ),
    ]
